﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.51
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Public UpdateURL As String
	Public CurrentAppVersion As Int
	Private xui As XUI
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
End Sub

Public Sub CheckForUpdates As ResumableSub
	Log("CheckForUpdates")
	Wait For (DownloadVersion) Complete (Result As String)
	If Result = "False" Then 'An error occurred getting the version information
		Log("CheckForUpdates False")
		Return False
	End If
	
	'Dim Result2 As String = "True"	
	Wait For (CheckVersion(Result)) Complete (Result2 As String)

	If Result2 = "Forced" Then 'We canceled a forced update, lets kill the software
		Log("CheckForUpdates ExitApplication2")
		ExitApplication2(1)
	Else if Result2 = "True" Then 'there is an accepted update available
		Wait For (GetInstaller) Complete (Result3 As Boolean)
		If Result3 = True Then 'Update Downloaded
			Log("CheckForUpdates ExitApplication")
			ExitApplication
		End If
	End If
	Log("CheckForUpdates True")
	Return True
End Sub

Private Sub DownloadVersion As ResumableSub
	Log("DownloadVersion")
	Dim http As HttpJob
	http.Initialize("", Me)
	http.Username = "updater"
	http.Password = "scoreboardapkupdate"
	http.Download(UpdateURL & "version.txt")
	Wait For (http) JobDone(http As HttpJob)
	If http.Success = True Then
		Dim VersionData As String = http.GetString
		http.Release 'Make sure to call this here, or we can end up with a memory leak. Dont want that.
		Log("DownloadVersion " & VersionData)
		Return VersionData
	End If
	http.Release
	Log("DownloadVersion False")
	Return "False"
End Sub

Private Sub CheckVersion(VersionInfo As String) As ResumableSub
	Log("CheckVersion")
	If Main.Left(VersionInfo, 7) <> "version" Then 'Invalid File Format
		Log("CheckVersion False")
		Return "False"
	End If
	Dim Args() As String = Regex.Split(",", VersionInfo)
	Dim V() As String = Regex.Split("=", Args(0)) 'Get Version Info
	If Main.Val(V(1)) > CurrentAppVersion Then 'There is a newer version
		Dim Active() As String = Regex.Split("=", Args(1)) 'Get Active Update state
		If Active(1) <> "true" Then Return "False" 'the newer update is not currently active yet
		Dim Forced() As String = Regex.Split("=", Args(2)) 'Check to see if this update is required for operation.
		Dim Changelog() As String = Regex.Split("=", Args(3)) 'Get the changelog information
		Dim ChangelogData() As String = Regex.Split(";", Changelog(1)) 'Get the changelog data block
		Dim I As Int = 0
		Dim Count As Int = 0
		Dim ChangeLogPrompt As String
		For I = 0 To ChangelogData.Length-1 'Go through each item in the change log and display only what is relevant to us.
			Dim Arr() As String = Regex.Split(":", ChangelogData(I))
			If Main.Val(Arr(0)) >= CurrentAppVersion Then 'Display the information if its current to our version and newer. Dont display irrelevent information.
				If Count = 0 Then 'First entry valid to our version, which is our current version.
					ChangeLogPrompt = ChangeLogPrompt & Arr(1) & " - Your Version" & Chr(13)
				Else if I = Changelog.Length-1 Then
					ChangeLogPrompt = ChangeLogPrompt & Arr(1) & " - Current Version" & Chr(13)
				Else
					ChangeLogPrompt = ChangeLogPrompt & Arr(1) & Chr(13)
				End If
				ChangeLogPrompt = ChangeLogPrompt & Arr(2) & Chr(13) & Chr(13) 'double space
				Count = Count + 1
			End If
		Next
		Dim sf As Object = xui.Msgbox2Async("There is a software update available for download. Do you wish to update?" & Chr(10) & Chr(13) & "Changelog:" & Chr(13) & ChangeLogPrompt, _
		"Software Update", "Yes", "", "No", Null)
		Wait For (sf) Msgbox_Result (Result As Int)
		If Result = xui.DialogResponse_Positive Then
			Log("CheckVersion True")
			Return "True"
		Else
			If Forced(1) = "true" Then 'Deny program access until the update is complete
				Wait For (xui.MsgboxAsync("You must perform the software update before you can continue to run this software", "Update REQUIRED")) Msgbox_Result (Result As Int)
				Log("CheckVersion Forced")
				Return "Forced"
			End If
			Log("Update Canceled")
			Log("CheckVersion False")
			Return "False"
		End If
	End If
	Log("CheckVersion False")
	Return "False"
End Sub

public Sub GetInstaller As ResumableSub	
	Log("GetInstaller")
	Dim http1 As HttpJob
	http1.Initialize("", Me)
	http1.Username = "updater"
	http1.Password = "scoreboardapkupdate"
	Log("UpdateURL=" & UpdateURL)
	http1.Download(UpdateURL & "installer.exe")
	Log("...")
	Wait For (http1) JobDone(http1 As HttpJob)
	If http1.Success = True Then
		Log("Success")
		Log("See " & File.DirTemp)
		Dim out As OutputStream = File.OpenOutput(File.DirTemp, "installer.exe", False)
		File.Copy2(http1.GetInputStream, out)
		out.Close
		http1.Release
		Dim sh1 As Shell
		sh1.Initialize("sh1", File.Combine(File.DirTemp, "installer.exe"), Null)
		sh1.Run(-1)
		Log("GetInstaller True <<<<<<<")
		Return True
	Else
		http1.Release
		Log("Failed to download setup file")
		Log("GetInstaller False")
		Return False
	End If
End Sub
